{% load static %}
{% block content %}
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="stylesheet" href="{% static 'css/main.css' %}"/>
        <title>Connect 2 Order</title>
        <script type="text/javascript">
            var user = '{{request.user}}'
    
            function getToken(name) {
                var cookieValue = null;
                if (document.cookie && document.cookie !== '') {
                    var cookies = document.cookie.split(';');
                    for (var i = 0; i < cookies.length; i++) {
                        var cookie = cookies[i].trim();
                        if (cookie.substring(0, name.length + 1) === (name + '=')) {
                            cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                            break;
                        }
                    }
                }
                return cookieValue;
            }
            var csrftoken = getToken('csrftoken')
            

            function getCookie(name) {
		        var cookieArr = document.cookie.split(";");

		        for(var i = 0; i < cookieArr.length; i++) {
		            var cookiePair = cookieArr[i].split("=");

		            if(name == cookiePair[0].trim()) {
		                return decodeURIComponent(cookiePair[1]);
		            }
		        }

		        return null;
		    }
		    var cart = JSON.parse(getCookie('cart'))

		    if (cart == undefined){
			    cart = {}
			    console.log('Cart Created!', cart)
			    document.cookie ='cart=' + JSON.stringify(cart) + ";domain=;path=/"
		    }
		    console.log('Cart:', cart)
        
        </script>
    </head>
    <body>
        <nav>
            <div class="wrapper">
                <div class="logo">
                    <h2 style="color: #df1212;">Connect 2 Order</h2>
                </div>
                <div class="nav-links">
                    <li><a href="/connect">Products</a></li>
                    <li><a href="/">Home</a></li>
                </div>
                <div class="nav-links-fa">
                    <a href="/cart"><i class="fa-solid fa-cart-shopping">{{cartItems}}</i></a>
                    <a href="/loginUser"><i class="fa-regular fa-user"></i></a>
                    <div class="menu">
                        <i class="fa-solid fa-bars"></i>
                    </div>
                </div>
            </div>
        </nav>
        <section class="specification">
        </section>
        <div class="row">
            <div class="col-lg-6">
                <div class="box-element">
                    <a href="/cart" class="alink"><button class="p-cart"> Back to Cart</button></a>
                    <hr>
                    <h3>Order Summary</h3>
                    <hr>
                    {% for item in items %}
                    <div class="cart-row">
                        <div style="flex:2"><img class="row-image" src="{{item.product.imageURL}}"></div>
                        <div style="flex:2"><h4>{{item.product.name}}</h4></div>
                        <div style="flex:1"><p>shs {{item.product.price|floatformat:1}}</p></div>
                        <div style="flex:1"><h5>X {{item.quantity}}</h5></div>
                    </div>
                    {% endfor %}
                    <h4>Items:   {{order.get_cart_items}}</h4>
                    <h3 style="color: #df1212;">Total:   shs {{order.get_cart_total|floatformat:1}}</h3>
                </div>
            </div>
            <div class="col-lg-6">
                <div class="box-element" id="form-wrapper">
                    <form id="form">
                        <div id="user-info">
                            <div class="form-field">
                                <input required class="form-control" type="text" name="name" placeholder="Name..">
                            </div>
                            <div class="form-field">
                                <input required class="form-control" type="email" name="email" placeholder="Email..">
                            </div>
                        </div>
                        
                        <div id="shipping-info">
                            <hr>
                            <h3>Shipping Information:</h3>
                            <hr>
                            <div class="form-field">
                                <input class="form-control" type="text" name="address" placeholder="Address..">
                            </div>
                            <div class="form-field">
                                <input class="form-control" type="text" name="city" placeholder="City..">
                            </div>
                        </div>
    
                        <hr>
                        <button class="p-cart" id="form-button" class="btn btn-success btn-block" type="submit" value="Continue">Continue</button>
                    </form>
                </div>
                <br>
			        <div class="box-element hidden" id="payment-info">
				        <button class="p-cart" id="make-payment">Complete Order</button>
			        </div>
            </div>
        </div>
        <script type="text/javascript" src="{% static 'js/cart.js' %}"></script>
        <script src="https://kit.fontawesome.com/f8a9fd1092.js" crossorigin="anonymous"></script>
    
        <script>
            const menuBtn = document.querySelector('.menu')
            const navlinks = document.querySelector('.nav-links')

            menuBtn.addEventListener('click',()=>{
                navlinks.classList.toggle('mobile-menu')
            })
        </script>

        <script type="text/javascript">
            var shipping = '{{order.shipping}}'
            var total = '{{order.get_cart_total|floatformat:1}}'
    
            if (shipping == 'False'){
                 document.getElementById('shipping-info').innerHTML = ''
            }
    
            if (user != 'AnonymousUser'){
                 document.getElementById('user-info').innerHTML = ''
             }
    
            if (shipping == 'False' && user != 'AnonymousUser'){
                //Hide entire form if user is logged in and shipping is false
                    document.getElementById('form-wrapper').classList.add("hidden");
                    //Show payment if logged in user wants to buy an item that does not require shipping
                    document.getElementById('payment-info').classList.remove("hidden");
            }
    
            var form = document.getElementById('form')
            form.addEventListener('submit', function(e){
                e.preventDefault()
                console.log('Form Submitted...')
                document.getElementById('form-button').classList.add("hidden");
                document.getElementById('payment-info').classList.remove("hidden");
            })
    
            document.getElementById('make-payment').addEventListener('click', function(e){
                submitFormData()
            })
    
            function submitFormData(){
                console.log('Payment button clicked')
    
                var userFormData = {
                    'name':null,
                    'email':null,
                    'total':total,
                }
    
                var shippingInfo = {
                    'address':null,
                    'city':null,
                }
    
                if (shipping != 'False'){
                    shippingInfo.address = form.address.value
                    shippingInfo.city = form.city.value
                }
    
                if (user == 'AnonymousUser'){
                    userFormData.name = form.name.value
                    userFormData.email = form.email.value
                }
    
                console.log('Shipping Info:', shippingInfo)
                console.log('User Info:', userFormData)
    
                var url = "/process_order/"
                fetch(url, {
                    method:'POST',
                    headers:{
                        'Content-Type':'applicaiton/json',
                        'X-CSRFToken':csrftoken,
                    }, 
                    body:JSON.stringify({'form':userFormData, 'shipping':shippingInfo}),
                    
                })
                .then((response) => response.json())
                .then((data) => {
                    console.log('Success:', data);
                    alert('Transaction completed');

                    cart = {}
				    document.cookie ='cart=' + JSON.stringify(cart) + ";domain=;path=/"

                    window.location.href = "{% url 'home' %}"
    
                    })
            }
        </script>
    </body>
</html>
{% endblock content %}